<form (submit)="uploadPaper()" #uploadPaperForm="ngForm" name="uploadForm">
  <div class="alert alert-info" role="alert">To upload a Paper, please fill out every field.</div>
  <div class="form-group">
    <label for="Upload Type">Make my Paper reviewable</label>
      <input type="checkbox"
      [(ngModel)]="isPaperReviewable"
      [ngModelOptions]="{standalone: true}"/>
  </div>
  <div class="form-group" *ngIf="paper?.paperIpfsHashIdentification">
      <label for="Reupload check">Upload a new version</label>
        <input type="checkbox"
        [(ngModel)]="isReupload"
        [ngModelOptions]="{standalone: true}"/>
    </div>
    <div class="form-group" *ngIf="!paper?.paperIpfsHashIdentification || isReupload">
      <label for="Fileupload">Fileupload</label>
      <input type="file" name="file"
      (change)="setPaperFile($event.target.files)"/>
    </div>
    <div class="form-group">
        <label>Title</label>
        <input type="text" class="form-control" id="title"
        [(ngModel)]="paper?.paperDetails.title" name="title" #title="ngModel" required>
        <div [hidden]="title.valid || title.pristine"
            class="alert alert-danger">
            Title is required!
        </div>
    </div>
    <div class="form-group">
        <label>Author</label>
        <input type="text" class="form-control" id="author"
        [(ngModel)]="paper?.paperDetails.author" name="author" required #author="ngModel">
        <div [hidden]="author.valid || author.pristine"
            class="alert alert-danger">
            Author is required!
        </div>
    </div>
    <div class="form-group" *ngIf="!paper?.paperIpfsHashIdentification">
        <label>Mainfield</label>
        <div>
          <select [(ngModel)]="selectedMainTag"
          (ngModelChange)="updateSubField($event)"
          name="mainField">
            <option style="display:none">select a category</option>
            <option *ngFor="let mainTag of paperTags" [ngValue]="mainTag">
              {{mainTag.mainFieldLabel}}</option>
          </select>
        </div>
      </div>
    <div class="form-group" *ngIf="!paper?.paperIpfsHashIdentification">
      <label>Subfield</label>
      <div>
        <select [(ngModel)]="selectedSubTag" name="subfield">
          <option style="display:none">select a category</option>
          <option *ngFor="let subTag of selectedSubTags" [ngValue]="subTag">{{subTag.subFieldLabel}}</option>
        </select>
      </div>
    </div>
    <div class="form-group">
        <label>Abstract</label>
        <textarea class="form-control" rows="5" id="abstract"
        [(ngModel)]="paper?.paperDetails.abstract" name="abstract" #abstract="ngModel" required>
        </textarea>
        <div [hidden]="abstract.valid || abstract.pristine"
            class="alert alert-danger">
            Abstract is required!
        </div>
    </div>

    <div class="form-group" *ngIf="isPaperReviewable">
        <label>Paper Price</label>
        <div class="input-group">
            <input type="number" class="form-control" id="paperPrice"
            [(ngModel)]="paper?.paperDetails.price" name="paperPrice" #price="ngModel" required>
            <span class="input-group-addon">Microether</span>
        </div>
        <div [hidden]="price.valid || price.pristine || price.value > 0"
            class="alert alert-danger">
            Price is required and has to be positive
        </div>
    </div>

    <div class="form-group" *ngIf="isPaperReviewable">
        <label>Review Slots</label>
        <input type="number" class="form-control" id="reviewSlots" min="1"
        [(ngModel)]="paper?.paperDetails.reviewSlots" name="reviewSlots" #slots="ngModel" required>
        <div [hidden]="slots.valid || slots.pristine || slots.value > 0"
            class="alert alert-danger">
            Slots are required and have to be greater than 0!
        </div>
    </div>

    <div class="form-group" *ngIf="isPaperReviewable">
        <label>Review Price</label>
        <div class="input-group">
            <input type="number" class="form-control" id="reviewPrice"
                [(ngModel)]="paper?.paperDetails.reviewPrice" name="reviewPrice" #reviewPrice="ngModel" required>
            <span class="input-group-addon">Microether</span>
        </div>
        <div [hidden]="reviewPrice.valid || reviewPrice.pristine || reviewPrice.value > 0"
            class="alert alert-danger">
            Price is required and has to be positive!
        </div>
    </div>

    <div class="form-group" *ngIf="isPaperReviewable">
        <label>Review Deadline</label>
        <input type="date" class="form-control" id="paperReviewDeadline"
        [ngModel]="paper?.paperDetails.reviewDeadline | date: 'yyyy-MM-dd'" name="paperReviewDeadline" required (ngModelChange)="paper.paperDetails.reviewDeadline = moment($event, 'yyyy-MM-dd').toDate()">
    </div>
    <button type="submit" class="btn btn-primary" [disabled]="!uploadPaperForm.valid || !paperFile"
    *ngIf="!paper?.paperIpfsHashIdentification">Upload</button>
    <button type="button" class="btn btn-primary" *ngIf="paper?.paperIpfsHashIdentification" (click)="updatePaper()" [disabled]="!uploadPaperForm.valid">Update</button>
</form>
